
Redmine - Feature #9445

Add Issue custom fields of User-format to the cross-project issuelist filters

2011-10-21 10:57 - Lubor Nosek

Status: Closed Start date: 2011-10-21

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Custom fields Estimated time: 0.00 hour

Target version:    

Resolution: Duplicate   

Description

We have added custom field into Issues named Supervisor which is a User format and checked Use as filter and For all projects.

When we display all issues (/issues) this custom field cannot be used as a filter.

I think the reason behind this is that the custom field maps on project users and these users are different across different projects.

Nevertheless I think that current behaviour is not correct and this custom field should be enabled as a filter in all issues display.

We're using Redmine 1.2.1.stable.6294 (MySQL)

Related issues:

Related to Redmine - Defect #10176: Custom fields of type "User" can't be ord... Closed

Related to Redmine - Defect #18940: Filter by custom user field didn´t work Closed

Has duplicate Redmine - Defect #9689: Cannot use a custom field with User for... Closed 2011-11-29

Has duplicate Redmine - Defect #9924: Custom field not filter option at globa... Closed

Has duplicate Redmine - Defect #9920: Custom fields of type "User" can't be o... Closed

Is duplicate of Redmine - Defect #24769: User custom field filter lists only ... Closed

History

#1 - 2011-10-21 10:58 - Lubor Nosek

Please correct spelling mistake in Subject: filed -> field

#2 - 2011-10-21 17:01 - Mischa The Evil

- Tracker changed from Defect to Feature

- Subject changed from Issue custom filed with User type cannot be filtered globally to Add Issue custom fields of User-format to the cross-project

issuelist filters

Corrected.

#3 - 2011-11-29 18:53 - pasquale [:dedalus]

+1

#4 - 2011-11-30 11:52 - pasquale [:dedalus]

I don't agree that this is a feature and not a bug because assignee-to is a User format type

#5 - 2012-02-01 18:43 - Joe Cullin

+1

#6 - 2012-04-13 16:26 - Fernando Hartmann

+1

#7 - 2012-09-25 08:46 - Vincent Desmarets

+1

this is a really important fix for my projects. without this we cannot have an overall view on all projects
#8 - 2012-09-25 08:47 - Vincent Desmarets

- Assignee set to Mischa The Evil

#9 - 2013-02-27 12:09 - James Silver

+1!

Very important for those of us using a custom user field for things like "Supervisor" fields.

Thanks!

#10 - 2013-02-27 12:26 - Koen Boone

+100!

I have a custom user field for issues that is available for ALL projects, but it's not available in the filter for issues for all projects, only in lists per

project.

Maybe this is because it's not used yet in all issues, but I think it's also related to this thread.

#11 - 2013-02-28 04:30 - Mischa The Evil

- Assignee deleted (Mischa The Evil)

Vincent Desmarets wrote:

Assignee set to Mischa The Evil

 Please don't randomly assign issues.

#12 - 2013-10-22 18:28 - Branden Strickland

All,

I've mucked around a bit and gotten this to work.

This is with the EXPRESS WARNING that it may break other things - and that I've hacked mine a bit on the dirty side and need to clean it up.

In models/querys.rb

at

def add_custom_fields_filters(custom_fields, assoc=nil)

 Down where it says

When "user", "version" 

next unless project

values = field.possible_values_options(project)

 I've just commented out "next unless project" which as I understand is basically requiring a project to be associated with that custom field type.  I want

global - so I"m willing to risk a bit of wierdness to get it since it's a deal-breaker not to have it.

This was done with the help of rchady in IRC - and he's warned me this could blow up as well - but I'm willing to risk it and test on my testing env.  So

far it's exactly as intended.

This should also be broken up between user vs version to make it cleaner.

I may regret this later but as of now - I'm getting my global "view all tickets" custom query to take in account a custom user field and I love it - The

boss is pretty happy too! (until it breaks!)

#13 - 2013-10-23 05:13 - Mischa The Evil

Branden Strickland wrote:

I've mucked around a bit and gotten this to work.

[...]

In models/querys.rb at def add_custom_fields_filters(custom_fields, assoc=nil), down where it says: 

when "user", "version" 

  next unless project

  values = field.possible_values_options(project)
I've just commented out "next unless project"

[...]   

I don't see how this could work. Do you really see (other) project members shown as possible values for the filter on the cross-project issue list?

AFAICS the only possible value that could be shown in this filter after a change like this is "<< me >>".

#14 - 2013-10-23 14:57 - Branden Strickland

- File ScreenHunter_13 Oct. 23 08.54.jpg added

I'm happy to provide further details.

OH!  I see what you're saying Mischa!  Yeah - It only gives the option for <<me>>  But in our case - this is what we needed since we're looking to

display tickets that are either owned by the person, or if they're a direct supporting owner.

I've not needed to - nor have I attempted to make that searchable for other peoples names.  Although I would suspect possibly doing something with

user.current.logged and mucking with the field == {'custom value db field'} or something that would allow the same functionality of selecting possible

users for watchers or assigned_to_id but I'm just shooting that off the hip.

#15 - 2013-11-26 21:07 - Branden Strickland

Just an update - I finally had the question posed to me "Hey - can we have custom filters with options other than "<<me>>"?  Us managers should be

able to see for any person.

Well as Mischa The Evil mentioned earlier, it's not that easy (duh).  I hacked around for about 30 minutes until I decided I should stick to PHP... Also -

I started looking at this outside the box.

If need be - You can do what I did to make up for this (not pretty - buckle in!)

I went into the database - where I'm comfortable (much more so than in Ruby) and I saw that the Queries Table lists all of the public and private

custom queries.  I then referenced the User Table and found if I do something like so

INSERT INTO `redmine`.`queries` (`name`, `filters`, `user_id`, `is_public`, `column_names`, `sort_criteria`, `

group_by`, `type`) VALUES ('Example', '---\nstatus_id:\n  :operator: o\n  :values:\n  - \'\'\nuseor:\n  :opera

tor: =\n  :values:\n  - \'Yes\'\nassigned_to_id:\n  :operator: =\n  :values:\n  - {USERID}\ncf_1:\n  :operator

: =\n  :values:\n  - {USERID}\n', 3, 1, '---\n- :project\n- :tracker\n- :subject\n- :status\n- :priority\n- :p

arent\n- :assigned_to\n- :cf_1\n- :done_ratio\n- :due_date\n- :estimated_hours\n- :spent_hours\n', '---\n- - d

ue_date\n  - asc\n', '', 'IssueQuery');

 Where cf_1 is the id of the custom field.  and {USERID} is the.. well.. Userid from the users table.

To simplify - if you were to edit just the filter column in something like... HeidiSQL it would like like so:

---

status_id:

  :operator: o

  :values:

  - ''

useor:

  :operator: =

  :values:

  - 'Yes'

assigned_to_id:

  :operator: =

  :values:

  - '12'

cf_1:

  :operator: =

  :values:

  - '12'

 That I could hack out custom queries for my users.  This is NOT for someone who has to do super custom for > 10 users, but in my case I just need

to create 10 or so public queries to show all tickets accross all projects that were either assigned to OR marked as "Other Assignee" (a custom field)

on the ticket.

A note!  This does require the "OR" filter plugin that is available in the plugins section.

#16 - 2014-04-17 13:58 - Ty You

This is a whammy for us, too.  I'm on 2.3.2.stable - does anyone know if this has been addressed in subsequent versions?  I can't hack core, too

much pressure ;-)

#17 - 2014-08-06 13:14 - Alexander Molchanov

+1
#18 - 2014-12-07 19:46 - Anders Thomsen

+1

#19 - 2014-12-08 22:29 - Anders Thomsen

Managed to get this sort of working.

It fetches all active users from the entire DB!!!

One bug though: when browsing to an issue from the ROOT/issues page, it loads all users but does not add it anywhere to the rendered page. This is

even though I test if there is a project with project.nil?. When browsing to an issue from the ROOT/project/issues page it skips loading all users, like it

should.

In app/models/query.rb

  def add_custom_field_filter(field, assoc=nil)

    options = field.format.query_filter_options(field, self)

    if field.format.target_class && field.format.target_class <= User

# BEGIN PATCH

       # If showing all issues in all projects, select all active users

      if options[:values].is_a?(Array) && project.nil? &&         

        options[:values] = User.active.sorted.collect {|u| [u.to_s, u.id.to_s]} 

      end

# END PATCH

      if options[:values].is_a?(Array) && User.current.logged?

        options[:values].unshift ["<< #{l(:label_me)} >>", "me"]        

      end      

    end

...

#20 - 2014-12-09 22:59 - Anders Thomsen

Even better solution. It now shows all members of projects and uses the same list as "watchers":

In app/models/query.rb

 # Adds a filter for the given custom field

  def add_custom_field_filter(field, assoc=nil, valid_users=nil)

    options = field.format.query_filter_options(field, self)

    if field.format.target_class && field.format.target_class <= User

      if options[:values].is_a?(Array) && User.current.logged?

        options[:values].unshift ["<< #{l(:label_me)} >>", "me"]

      end

      if options[:values].is_a?(Array) && project.nil? && !valid_users.nil?        

        options[:values] += valid_users.collect {|u| [u.name, u.id.to_s]} 

      end      

    end

...

 
  def add_custom_fields_filters(scope, assoc=nil, valid_users=nil)

    scope.visible.where(:is_filter => true).sorted.each do |field|

      add_custom_field_filter(field, assoc, valid_users)

    end

  end

 In app/models/issue_query.rb in the method initialize_available_filters add users to the parameter list like so:

    add_custom_fields_filters(issue_custom_fields, nil, users)

 Tested on version 2.5.2

#21 - 2015-01-19 18:31 - Anton Statutov

How about making patch for this?

#22 - 2015-02-13 08:11 - Mischa The Evil

- Related to Defect #18940: Filter by custom user field didn´t work added

#23 - 2015-07-26 23:00 - Arkhitech - More, Better, Faster!

+1
#24 - 2015-08-07 16:48 - Anders Thomsen

- File 0001-Add-Issue-custom-fields-of-User-format-to-the-cross-.patch added

My changes as a patch for 2.6.6. Not tested with 3.x

#25 - 2015-12-02 05:19 - Jens Krämer

- File issue_9445_user_custom_field_global_queries.diff added

I can confirm that this change also works on trunk, just the line numbers in the original patch are a bit off.

#26 - 2015-12-02 05:58 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#27 - 2015-12-16 18:08 - Anders Thomsen

I'm using the patch against 3.1 with no problems. So it seems to work.

What's the next step? Should I submit it as a patch or just leave it here and get the devs' attention somehow?

#28 - 2015-12-31 04:46 - Toshi MARUYAMA

Anders Thomsen wrote:

I'm using the patch against 3.1 with no problems. So it seems to work.

What's the next step? Should I submit it as a patch or just leave it here and get the devs' attention somehow?

 Please add tests.

#29 - 2016-10-05 11:22 - Chandranshu .

The patch is good as a workaround hack but I don't think we should merge it to the trunk yet. I have configured my custom field to only allow users of

a particular role but using this patch, I can see all the users listed in the filter drop-down. I'll try to improve this patch to take that into account.

#30 - 2017-05-01 19:59 - Kirill Persionov

I tested your patch - it works for me.

But requests are sometimes performed for a very long time.

#31 - 2017-08-25 10:14 - Uy Nguyen

Hi Anders Thomsen,

It works for me in 3.1, I want to add custom field to my page cus I use it like Multiple-Assignee.

Now, I'm trying to add CustomField to show on My Page but I don't know to dit it :(

anyway, Thanks Anders!

#32 - 2017-09-12 12:38 - Anders Thomsen

I believe this should be marked as a duplicate of #24769 which is resolved in 3.4.0

#33 - 2017-09-23 12:26 - Toshi MARUYAMA

- Status changed from New to Closed

- Target version deleted (Candidate for next minor release)

- Resolution set to Duplicate

Anders Thomsen wrote:

I believe this should be marked as a duplicate of #24769 which is resolved in 3.4.0

 Indeed.

#34 - 2017-09-23 12:27 - Toshi MARUYAMA

- Is duplicate of Defect #24769: User custom field filter lists only "Me" on cross project issue list added
